import 'package:nui_core/data/nui_ent.dart';
import 'package:nui_log/nui_log_models.dart';

class NUILogSaveLogRequest extends NUIEnt<NUILogSaveLogRequest>{
  NUILogSaveLogRequest({this.list});
  NUILogSaveLogRequest.empty();
  List<NUILogContent> list;

  @override
  NUIEntMapper<NUILogSaveLogRequest> mapper() => NUILogSaveLogRequestEntity();
}
class NUILogSaveLogRequestEntity extends NUIEntMapper<NUILogSaveLogRequest>{
  @override
  String entityName() => "NUILogSaveLogRequest";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUILogSaveLogRequest>(name: "list", type: NUIEntType.LIST_OBJECT, setter: (data, value) => data.list = asListOfObjects<NUILogContent>(NUILogContentEntity(), value), getter: (data) => data.list)
    ];
  }

  @override
  NUILogSaveLogRequest newInstance() => NUILogSaveLogRequest.empty();
}

class NUILogCheckSettingResponse extends NUIEnt<NUILogCheckSettingResponse>{
  NUILogCheckSettingResponse.empty();
  bool success;
  DateTime lastSyncDate;
  String sessionId;
  List<NUILogSetting> data;
  NUILogErrorResponse error;
  NUILogErrorResponse appVersionOutdated;

  @override
  NUIEntMapper<NUILogCheckSettingResponse> mapper() => NUILogCheckSettingResponseEntity();
}
class NUILogCheckSettingResponseEntity extends NUIEntMapper<NUILogCheckSettingResponse>{
  @override
  String entityName() => "NUILogCheckSettingResponse";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUILogCheckSettingResponse>(name: "success", type: NUIEntType.BOOLEAN, setter: (data, value) => data.success = value, getter: (data) => data.success),
      NUIEntField<NUILogCheckSettingResponse>(name: "lastSyncDate", type: NUIEntType.DATE, setter: (data, value) => data.lastSyncDate = asDateTime(value), getter: (data) => data.lastSyncDate),
      NUIEntField<NUILogCheckSettingResponse>(name: "sessionId", type: NUIEntType.STRING, setter: (data, value) => data.sessionId = value, getter: (data) => data.sessionId),
      NUIEntField<NUILogCheckSettingResponse>(name: "data", type: NUIEntType.LIST_OBJECT, setter: (data, value) => data.data = asListOfObjects<NUILogSetting>(NUILogSettingEntity(), value), getter: (data) => data.data),
      NUIEntField<NUILogCheckSettingResponse>(name: "error", type: NUIEntType.OBJECT, setter: (data, value) => data.error = asObject<NUILogErrorResponse>(NUILogErrorResponseEntity(), value), getter: (data) => data.error),
      NUIEntField<NUILogCheckSettingResponse>(name: "appVersionOutdated", type: NUIEntType.OBJECT, setter: (data, value) => data.appVersionOutdated = asObject<NUILogErrorResponse>(NUILogErrorResponseEntity(), value), getter: (data) => data.appVersionOutdated),
    ];
  }

  @override
  NUILogCheckSettingResponse newInstance() => NUILogCheckSettingResponse.empty();
}

class NUILogErrorResponse extends NUIEnt<NUILogErrorResponse>{
  NUILogErrorResponse.empty();
  String code;
  String message;

  @override
  NUIEntMapper<NUILogErrorResponse> mapper() => NUILogErrorResponseEntity();
}
class NUILogErrorResponseEntity extends NUIEntMapper<NUILogErrorResponse>{
  @override
  String entityName() => "NUILogErrorResponse";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUILogErrorResponse>(name: "code", type: NUIEntType.STRING, setter: (data, value) => data.code = value, getter: (data) => data.code),
      NUIEntField<NUILogErrorResponse>(name: "message", type: NUIEntType.STRING, setter: (data, value) => data.message = value, getter: (data) => data.message),
    ];
  }

  @override
  NUILogErrorResponse newInstance() => NUILogErrorResponse.empty();
}